/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC15F4K60S4 ϵ ADתжϷʽ----------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966-------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.GXWMCU.com --------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ        */
/* ҪӦô˴,עʹSTCϼ        */
/*---------------------------------------------------------------------*/

//ʾKeilѡIntel8058оƬͺŽб
//ر˵,ƵһΪ11.0592MHz


#include "reg51.h"
#include "intrins.h"

#define FOSC    11059200L
#define BAUD    9600

typedef unsigned char BYTE;
typedef unsigned int WORD;

#define     URMD    0           //0:ʹöʱ2Ϊʷ
                                //1:ʹöʱ1ģʽ0(16λԶģʽ)Ϊʷ
                                //2:ʹöʱ1ģʽ2(8λԶģʽ)Ϊʷ

sfr T2H   = 0xd6;               //ʱ28λ
sfr T2L   = 0xd7;               //ʱ28λ

sfr  AUXR       =   0x8e;       //Ĵ                              

sfr ADC_CONTR   =   0xBC;           //ADCƼĴ
sfr ADC_RES     =   0xBD;           //ADC8λ
sfr ADC_LOW2    =   0xBE;           //ADC2λ
sfr P1ASF       =   0x9D;           //P1ڵ2ܿƼĴ

#define ADC_POWER   0x80            //ADCԴλ
#define ADC_FLAG    0x10            //ADCɱ־
#define ADC_START   0x08            //ADCʼλ
#define ADC_SPEEDLL 0x00            //540ʱ
#define ADC_SPEEDL  0x20            //360ʱ
#define ADC_SPEEDH  0x40            //180ʱ
#define ADC_SPEEDHH 0x60            //90ʱ

void InitUart();
void SendData(BYTE dat);
void Delay(WORD n);
void InitADC();

BYTE ch = 0;                        //ADCͨ

void main()
{
    InitUart();                     //ʼ
    InitADC();                      //ʼADC
    IE = 0xa0;                      //ʹADCж
                                    //ʼADת
    while (1);
}

/*----------------------------
ADCжϷ
----------------------------*/
void adc_isr() interrupt 5 using 1
{
    ADC_CONTR &= !ADC_FLAG;         //ADCжϱ־

    SendData(ch);                   //ʾͨ
    SendData(ADC_RES);              //ȡ8λ͵

//    SendData(ADC_LOW2);           //ʾ2λ
    
    if (++ch > 7) ch = 0;           //лһͨ
    ADC_CONTR = ADC_POWER | ADC_SPEEDLL | ADC_START | ch;
}

/*----------------------------
ʼADC
----------------------------*/
void InitADC()
{
    P1ASF = 0xff;                   //P1ΪAD
    ADC_RES = 0;                    //Ĵ
    ADC_CONTR = ADC_POWER | ADC_SPEEDLL | ADC_START | ch;
    Delay(2);                       //ADCϵ粢ʱ
}

/*----------------------------
ʼ
----------------------------*/
void InitUart()
{
    SCON = 0x5a;                //ôΪ8λɱ䲨
#if URMD == 0
    T2L = 0xd8;                 //òװֵ
    T2H = 0xff;                 //115200 bps(65536-18432000/4/115200)
    AUXR = 0x14;                //T2Ϊ1Tģʽ, ʱ2
    AUXR |= 0x01;               //ѡʱ2Ϊ1Ĳʷ
#elif URMD == 1
    AUXR = 0x40;                //ʱ1Ϊ1Tģʽ
    TMOD = 0x00;                //ʱ1Ϊģʽ0(16λԶ)
    TL1 = 0xd8;                 //òװֵ
    TH1 = 0xff;                 //115200 bps(65536-18432000/4/115200)
    TR1 = 1;                    //ʱ1ʼ
#else
    TMOD = 0x20;                //öʱ1Ϊ8λԶװģʽ
    AUXR = 0x40;                //ʱ1Ϊ1Tģʽ
    TH1 = TL1 = 0xfb;           //115200 bps(256 - 18432000/32/115200)
    TR1 = 1;
#endif
}

/*----------------------------
ʹ
----------------------------*/
void SendData(BYTE dat)
{
    while (!TI);                    //ȴǰһݷ
    TI = 0;                         //ͱ־
    SBUF = dat;                     //͵ǰ
}

/*----------------------------
ʱ
----------------------------*/
void Delay(WORD n)
{
    WORD x;

    while (n--)
    {
        x = 5000;
        while (x--);
    }
}

