/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC15F4K60S4 ϵ PCAʵ16λʱ+16λⲿ+6/7/8λPWM-----*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966-------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.GXWMCU.com --------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ        */
/* ҪӦô˴,עʹSTCϼ        */
/*---------------------------------------------------------------------*/

//ʾKeilѡIntel8058оƬͺŽб
//ر˵,ƵһΪ11.0592MHz


#include "reg51.h"
#include "intrins.h"

#define FOSC    11059200L
#define T1ms    (FOSC / 1000)

typedef unsigned char BYTE;
typedef unsigned int WORD;
typedef unsigned long DWORD;

sfr P0M1 = 0x93;
sfr P0M0 = 0x94;
sfr P1M1 = 0x91;
sfr P1M0 = 0x92;
sfr P2M1 = 0x95;
sfr P2M0 = 0x96;
sfr P3M1 = 0xb1;
sfr P3M0 = 0xb2;
sfr P4M1 = 0xb3;
sfr P4M0 = 0xb4;
sfr P5M1 = 0xC9;
sfr P5M0 = 0xCA;
sfr P6M1 = 0xCB;
sfr P6M0 = 0xCC;
sfr P7M1 = 0xE1;
sfr P7M0 = 0xE2;

sfr P_SW1       = 0xA2;             //蹦лĴ1

#define CCP_S0 0x10                 //P_SW1.4
#define CCP_S1 0x20                 //P_SW1.5

sfr CCON        =   0xD8;           //PCAƼĴ
sbit CCF0       =   CCON^0;         //PCAģ0жϱ־
sbit CCF1       =   CCON^1;         //PCAģ1жϱ־
sbit CCF2       =   CCON^2;         //PCAģ2жϱ־
sbit CR         =   CCON^6;         //PCAʱпλ
sbit CF         =   CCON^7;         //PCAʱ־
sfr CMOD        =   0xD9;           //PCAģʽĴ
sfr CL          =   0xE9;           //PCAʱֽ
sfr CH          =   0xF9;           //PCAʱֽ
sfr CCAPM0      =   0xDA;           //PCAģ0ģʽĴ
sfr CCAPM1      =   0xDB;           //PCAģ1ģʽĴ
sfr CCAPM2      =   0xDC;           //PCAģ2ģʽĴ
sfr CCAP0L      =   0xEA;           //PCAģ0Ĵ LOW
sfr CCAP1L      =   0xEB;           //PCAģ1Ĵ LOW
sfr CCAP2L      =   0xEC;           //PCAģ2Ĵ LOW
sfr CCAP0H      =   0xFA;           //PCAģ0Ĵ HIGH
sfr CCAP1H      =   0xFB;           //PCAģ1Ĵ HIGH
sfr CCAP2H      =   0xFC;           //PCAģ2Ĵ HIGH
sfr PCA_PWM0    =   0xF2;           //PCAģ0PWMĴ
sfr PCA_PWM1    =   0xF3;           //PCAģ1PWMĴ
sfr PCA_PWM2    =   0xF4;           //PCAģ2PWMĴ

sbit PCA_LED1   =   P0^0;           //LED1
sbit PCA_LED2   =   P0^1;           //LED2
sbit PCA_LED3   =   P0^2;           //LED3

WORD value;
BYTE cnt;                           //洢PCAʱ
DWORD count0;                       //¼һεĲֵ
DWORD count1;                       //¼εĲֵ
DWORD length;                       //洢񵽵(count1 - count0)

void PCA_isr() interrupt 7 using 1
{
    if (CF)                         //жǷΪPCAʱж
    {
        CF = 0;
        cnt++;                      //PCAʱ+1
    }
    if (CCF0)                       //жǷΪCCF0ж(16λʱж)
    {
        CCF0 = 0;                   //жϱ־
        CCAP0L = value;
        CCAP0H = value >> 8;        //±Ƚֵ
        value += T1ms;
        PCA_LED1 = !PCA_LED1;
    }
    if (CCF1)                       //жǷΪCCF1ж(ж)
    {
        CCF1 = 0;
        count0 = count1;                //һεĲֵ
        ((BYTE *)&count1)[3] = CCAP1L;  //汾εĲֵ
        ((BYTE *)&count1)[2] = CCAP1H;
        ((BYTE *)&count1)[1] = cnt;
        ((BYTE *)&count1)[0] = 0;
        length = count1 - count0;       //βĲֵ,Ϊ񵽵
        PCA_LED2 = !PCA_LED2;
    }
    if (CCF2)                       //жǷΪCCF2ж(PWMж)
    {
        CCF2 = 0;
        PCA_LED3 = !PCA_LED3;
    }
}

void main()
{
    P0M0 = 0x00;
    P0M1 = 0x00;
    P1M0 = 0x00;
    P1M1 = 0x00;
    P2M0 = 0x00;
    P2M1 = 0x00;
    P3M0 = 0x00;
    P3M1 = 0x00;
    P4M0 = 0x00;
    P4M1 = 0x00;
    P5M0 = 0x00;
    P5M1 = 0x00;
    P6M0 = 0x00;
    P6M1 = 0x00;
    P7M0 = 0x00;
    P7M1 = 0x00;

    ACC = P_SW1;
    ACC &= ~(CCP_S0 | CCP_S1);      //CCP_S0=0 CCP_S1=0
    P_SW1 = ACC;                    //(P1.2/ECI, P1.1/CCP0, P1.0/CCP1, P3.7/CCP2)
    
//  ACC = P_SW1;
//  ACC &= ~(CCP_S0 | CCP_S1);      //CCP_S0=1 CCP_S1=0
//  ACC |= CCP_S0;                  //(P3.4/ECI_2, P3.5/CCP0_2, P3.6/CCP1_2, P3.7/CCP2_2)
//  P_SW1 = ACC;  
//  
//  ACC = P_SW1;
//  ACC &= ~(CCP_S0 | CCP_S1);      //CCP_S0=0 CCP_S1=1
//  ACC |= CCP_S1;                  //(P2.4/ECI_3, P2.5/CCP0_3, P2.6/CCP1_3, P2.7/CCP2_3)
//  P_SW1 = ACC;  

    CCON = 0;                       //ʼPCAƼĴ
                                    //PCAʱֹͣ
                                    //CF־
                                    //ģжϱ־
    CL = 0;                         //λPCAĴ
    CH = 0;
    CMOD = 0x09;                    //PCAʱԴΪϵͳʱ/1
                                    //ʹPCAʱж
    value = T1ms;
    CCAP0L = value;                 //PCAģ0ʵ16λʱ
    CCAP0H = value >> 8;            //ʼPCAģ0
    value += T1ms;
    CCAPM0 = 0x49;                  //PCAģ0ʵ16λʱ(1ms)
//  CCAPM0 = 0x4d;                  //PCAģ0ʵ16λʱ(1ms),ͬʱ嵽CEX0

    CCAP1L = 0;                     //PCAģ1ʵ16λ
    CCAP1H = 0;                     //ʼPCAģ1
    CCAPM1 = 0x21;                  //PCAģ1Ϊ16λģʽ(ز,ɲӸߵƽʼ),Ҳж
//  CCAPM1 = 0x11;                  //PCAģ1Ϊ16λģʽ(½ز,ɲӵ͵ƽʼ),Ҳж
//  CCAPM1 = 0x31;                  //PCAģ1Ϊ16λģʽ(/½ز,ɲߵƽߵ͵ƽ),Ҳж
    cnt = 0;                        //ʼ
    count0 = 0;
    count1 = 0;

    CCAP2L = 0x20;                  //PCAģ2ʵ6/7/8λPWM
    CCAP2H = 0x20;                  //ʼPCAģ2
    PCA_PWM2 = 0x00;                //PCAģ28λPWM,PWMռձΪ87.5% ((100H-20H)/100H)
//  PCA_PWM2 = 0x40;                //PCAģ27λPWM,PWMռձΪ75% ((80H-20H)/80H)
//  PCA_PWM2 = 0x80;                //PCAģ26λPWM,PWMռձΪ50% ((40H-20H)/40H)
    CCAPM2 = 0x42;                  //PCAģ2ΪPWMģʽ,ж
//  CCAPM2 = 0x53;                  //PCAģ2ΪPWMģʽ,Ҳ½ж
//  CCAPM2 = 0x63;                  //PCAģ2ΪPWMģʽ,Ҳж
//  CCAPM2 = 0x73;                  //PCAģ2ΪPWMģʽ,Ҳתж

    CR = 1;                         //PCAʱʼ
    EA = 1;

    while (1);
}

