/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC15F4K60S4 ϵ SPIģʽдⲿFlash(жϷʽ)----*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966-------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.GXWMCU.com --------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ        */
/* ҪӦô˴,עʹSTCϼ        */
/*---------------------------------------------------------------------*/

//ʾKeilѡIntel8058оƬͺŽб
//ر˵,ƵһΪ11.0592MHz

//ʾдĿFlashΪPM25LV040,ʹU7ͨ

#include "reg51.h"

typedef bit BOOL;
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;

#define FOSC            11059200L
#define BAUD            (65536 - FOSC / 4 / 115200)

#define NULL            0
#define FALSE           0
#define TRUE            1

sfr P0M1 = 0x93;
sfr P0M0 = 0x94;
sfr P1M1 = 0x91;
sfr P1M0 = 0x92;
sfr P2M1 = 0x95;
sfr P2M0 = 0x96;
sfr P3M1 = 0xb1;
sfr P3M0 = 0xb2;
sfr P4M1 = 0xb3;
sfr P4M0 = 0xb4;
sfr P5M1 = 0xC9;
sfr P5M0 = 0xCA;
sfr P6M1 = 0xCB;
sfr P6M0 = 0xCC;
sfr P7M1 = 0xE1;
sfr P7M0 = 0xE2;

sfr  AUXR           =   0x8e;                   //Ĵ
sfr P_SW1           =   0xa2;                   //蹦лĴ1
#define SPI_S0          0x04
#define SPI_S1          0x08

sfr SPSTAT          =   0xcd;                   //SPI״̬Ĵ
#define SPIF            0x80                    //SPSTAT.7
#define WCOL            0x40                    //SPSTAT.6
sfr SPCTL           =   0xce;                   //SPIƼĴ
#define SSIG            0x80                    //SPCTL.7
#define SPEN            0x40                    //SPCTL.6
#define DORD            0x20                    //SPCTL.5
#define MSTR            0x10                    //SPCTL.4
#define CPOL            0x08                    //SPCTL.3
#define CPHA            0x04                    //SPCTL.2
#define SPDHH           0x00                    //CPU_CLK/4
#define SPDH            0x01                    //CPU_CLK/16
#define SPDL            0x02                    //CPU_CLK/64
#define SPDLL           0x03                    //CPU_CLK/128
sfr SPDAT           =   0xcf;                   //SPIݼĴ

sbit SS             =   P2^4;                   //SPISS,ӵFlashCE

sfr IE2             =   0xAF;                   //жϿƼĴ2
#define ESPI            0x02                    //IE2.1

#define SFC_WREN        0x06                    //Flash
#define SFC_WRDI        0x04
#define SFC_RDSR        0x05
#define SFC_WRSR        0x01
#define SFC_READ        0x03
#define SFC_FASTREAD    0x0B
#define SFC_RDID        0xAB
#define SFC_PAGEPROG    0x02
#define SFC_RDCR        0xA1
#define SFC_WRCR        0xF1
#define SFC_SECTORER    0xD7
#define SFC_BLOCKER     0xD8
#define SFC_CHIPER      0xC7

void InitUart();
void SendUart(BYTE dat);
void InitSpi();
BYTE SpiShift(BYTE dat);
BOOL FlashCheckID();
BOOL IsFlashBusy();
void FlashWriteEnable();
void FlashErase();
void FlashRead(DWORD addr, DWORD size, BYTE *buffer);
void FlashWrite(DWORD addr, DWORD size, BYTE *buffer);

#define BUFFER_SIZE     1024                    //С
#define TEST_ADDR       0                       //FlashԵַ

BYTE xdata g_Buffer[BUFFER_SIZE];               //Flashд
BOOL g_fFlashOK;                                //Flash״̬
BOOL g_fSpiBusy;                                //SPIĹ״̬

void main()
{
    int i;
    
    P0M0 = 0x00;
    P0M1 = 0x00;
    P1M0 = 0x00;
    P1M1 = 0x00;
    P2M0 = 0x00;
    P2M1 = 0x00;
    P3M0 = 0x00;
    P3M1 = 0x00;
    P4M0 = 0x00;
    P4M1 = 0x00;
    P5M0 = 0x00;
    P5M1 = 0x00;
    P6M0 = 0x00;
    P6M1 = 0x00;
    P7M0 = 0x00;
    P7M1 = 0x00;

    //ʼFlash״̬
    g_fFlashOK = FALSE;
    g_fSpiBusy = FALSE;
    
    //ʼںSPI
    InitUart();
    InitSpi();

    //ʹSPIж
    IE2 |= ESPI;
    EA = 1;

    //Flash״̬
    FlashCheckID();
    
    //Flash
    FlashErase();
    //ȡԵַ
    FlashRead(TEST_ADDR, BUFFER_SIZE, g_Buffer);
    //͵
    for (i=0; i<BUFFER_SIZE; i++) SendUart(g_Buffer[i]);
    
    //޸û
    for (i=0; i<BUFFER_SIZE; i++) g_Buffer[i] = i>>2;
    //дFlash
    FlashWrite(TEST_ADDR, BUFFER_SIZE, g_Buffer);
    
    //ȡԵַ
    FlashRead(TEST_ADDR, BUFFER_SIZE, g_Buffer);
    //͵
    for (i=0; i<BUFFER_SIZE; i++) SendUart(g_Buffer[i]);
    
    FlashErase();
    //ȡԵַ
    FlashRead(TEST_ADDR, BUFFER_SIZE, g_Buffer);
    //͵
    for (i=0; i<BUFFER_SIZE; i++) SendUart(g_Buffer[i]);
    
    //޸û
    for (i=0; i<BUFFER_SIZE; i++) g_Buffer[i]= 255-(i>>2);
    //дFlash
    FlashWrite(TEST_ADDR, BUFFER_SIZE, g_Buffer);
    
    //ȡԵַ
    FlashRead(TEST_ADDR, BUFFER_SIZE, g_Buffer);
    //͵
    for (i=0; i<BUFFER_SIZE; i++) SendUart(g_Buffer[i]);
    
    while (1);
}

/************************************************
SPIжϷ
************************************************/
void spi_isr() interrupt 9 using 1
{
    SPSTAT = SPIF | WCOL;                       //SPI״̬λ
    g_fSpiBusy = FALSE;
}

/************************************************
ڳʼ
ڲ: 
ڲ: 
************************************************/
void InitUart()
{
    AUXR = 0x40;                                //öʱ1Ϊ1Tģʽ
    TMOD = 0x00;                                //ʱ1Ϊ16λģʽ
    TH1 = BAUD >> 8;                            //ò
    TL1 = BAUD;
    TR1 = 1;
    SCON = 0x5a;                                //ôΪ8λλ,ʿɱģʽ
}

/************************************************
ݵ
ڲ:
    dat : ׼͵
ڲ: 
************************************************/
void SendUart(BYTE dat)
{
    while (!TI);                                //ȴһݷ
    TI = 0;                                     //ɱ־
    SBUF = dat;                                 //εݷ
}

/************************************************
SPIʼ
ڲ: 
ڲ: 
************************************************/
void InitSpi()
{
//  ACC = P_SW1;                                //лһSPI
//  ACC &= ~(SPI_S0 | SPI_S1);                  //SPI_S0=0 SPI_S1=0
//  P_SW1 = ACC;                                //(P1.2/SS, P1.3/MOSI, P1.4/MISO, P1.5/SCLK)

    ACC = P_SW1;                                //ڲU7,U7ʹõǵڶSPIFlash
    ACC &= ~(SPI_S0 | SPI_S1);                  //SPI_S0=1 SPI_S1=0
    ACC |= SPI_S0;                              //(P2.4/SS_2, P2.3/MOSI_2, P2.2/MISO_2, P2.1/SCLK_2)
    P_SW1 = ACC;  

//  ACC = P_SW1;                                //лSPI
//  ACC &= ~(SPI_S0 | SPI_S1);                  //SPI_S0=0 SPI_S1=1
//  ACC |= SPI_S1;                              //(P5.4/SS_3, P4.0/MOSI_3, P4.1/MISO_3, P4.3/SCLK_3)
//  P_SW1 = ACC;  

    SPSTAT = SPIF | WCOL;                       //SPI״̬
    SS = 1;
    SPCTL = SSIG | SPEN | MSTR;                 //SPIΪģʽ
}

/************************************************
ʹSPIʽFlashݽ
ڲ:
    dat : ׼д
ڲ:
    Flashж
************************************************/
BYTE SpiShift(BYTE dat)
{
    g_fSpiBusy = TRUE;
    SPDAT = dat;                                //SPI
    while (g_fSpiBusy);                         //ȴSPIݴ
    
    return SPDAT;
}

/************************************************
FlashǷ׼
ڲ: 
ڲ:
    0 : ûм⵽ȷFlash
    1 : Flash׼
************************************************/
BOOL FlashCheckID()
{
    BYTE dat1, dat2;
    
    SS = 0;
    SpiShift(SFC_RDID);                         //ͶȡID
    SpiShift(0x00);                             //ն3ֽ
    SpiShift(0x00);
    SpiShift(0x00);
    dat1 = SpiShift(0x00);                      //ȡID1
    SpiShift(0x00);                             //ȡ豸ID
    dat2 = SpiShift(0x00);                      //ȡID2
    SS = 1;
                                                //ǷΪPM25LVxxϵеFlash
    g_fFlashOK = ((dat1 == 0x9d) && (dat2 == 0x7f));
    
    return g_fFlashOK;
}

/************************************************
Flashæ״̬
ڲ: 
ڲ:
    0 : Flashڿ״̬
    1 : Flashæ״̬
************************************************/
BOOL IsFlashBusy()
{
    BYTE dat;
    
    SS = 0;
    SpiShift(SFC_RDSR);                         //Ͷȡ״̬
    dat = SpiShift(0);                          //ȡ״̬
    SS = 1;
    
    return (dat & 0x01);                        //״ֵ̬Bit0Ϊæ־
}

/************************************************
ʹFlashд
ڲ: 
ڲ: 
************************************************/
void FlashWriteEnable()
{
    while (IsFlashBusy());                      //Flashæ
    SS = 0;
    SpiShift(SFC_WREN);                         //дʹ
    SS = 1;
}

/************************************************
ƬFlash
ڲ: 
ڲ: 
************************************************/
void FlashErase()
{
    if (g_fFlashOK)
    {
        FlashWriteEnable();                     //ʹFlashд
        SS = 0;
        SpiShift(SFC_CHIPER);                   //Ƭ
        SS = 1;
    }
}

/************************************************
Flashжȡ
ڲ:
    addr   : ַ
    size   : ݿС
    buffer : Flashжȡ
ڲ:
    
************************************************/
void FlashRead(DWORD addr, DWORD size, BYTE *buffer)
{
    if (g_fFlashOK)
    {
        while (IsFlashBusy());                  //Flashæ
        SS = 0;
        SpiShift(SFC_FASTREAD);                 //ʹÿٶȡ
        SpiShift(((BYTE *)&addr)[1]);           //ʼַ
        SpiShift(((BYTE *)&addr)[2]);
        SpiShift(((BYTE *)&addr)[3]);
        SpiShift(0);                            //Ҫնһֽ
        while (size)
        {
            *buffer = SpiShift(0);              //Զȡ
            addr++;
            buffer++;
            size--;
        }
        SS = 1;
    }
}

/************************************************
дݵFlash
ڲ:
    addr   : ַ
    size   : ݿС
    buffer : ҪдFlash
ڲ: 
************************************************/
void FlashWrite(DWORD addr, DWORD size, BYTE *buffer)
{
    if (g_fFlashOK)
    while (size)
    {
        FlashWriteEnable();                     //ʹFlashд
        SS = 0;
        SpiShift(SFC_PAGEPROG);                 //ҳ
        SpiShift(((BYTE *)&addr)[1]);           //ʼַ
        SpiShift(((BYTE *)&addr)[2]);
        SpiShift(((BYTE *)&addr)[3]);
        while (size)
        {
            SpiShift(*buffer);                  //ҳд
            addr++;
            buffer++;
            size--;
            if ((addr & 0xff) == 0) break;
        }
        SS = 1;
    }
}

