/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC15F4K60S4 ϵ ʱ11Ĳʷ------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966-------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.GXWMCU.com --------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ        */
/* ҪӦô˴,עʹSTCϼ        */
/*---------------------------------------------------------------------*/

//ʾKeilѡIntel8058оƬͺŽб
//ر˵,ƵһΪ11.0592MHz


#include "reg51.h"
#include "intrins.h"

typedef unsigned char BYTE;
typedef unsigned int WORD;

#define FOSC 11059200L          //ϵͳƵ
#define BAUD 115200             //ڲ

#define NONE_PARITY     0       //У
#define ODD_PARITY      1       //У
#define EVEN_PARITY     2       //żУ
#define MARK_PARITY     3       //У
#define SPACE_PARITY    4       //հУ

#define PARITYBIT EVEN_PARITY   //Уλ

sfr P0M1 = 0x93;
sfr P0M0 = 0x94;
sfr P1M1 = 0x91;
sfr P1M0 = 0x92;
sfr P2M1 = 0x95;
sfr P2M0 = 0x96;
sfr P3M1 = 0xb1;
sfr P3M0 = 0xb2;
sfr P4M1 = 0xb3;
sfr P4M0 = 0xb4;
sfr P5M1 = 0xC9;
sfr P5M0 = 0xCA;
sfr P6M1 = 0xCB;
sfr P6M0 = 0xCC;
sfr P7M1 = 0xE1;
sfr P7M0 = 0xE2;

sfr AUXR  = 0x8e;               //Ĵ

sfr P_SW1   = 0xA2;             //蹦лĴ1

#define S1_S0 0x40              //P_SW1.6
#define S1_S1 0x80              //P_SW1.7

sbit P22 = P2^2;

bit busy;

void SendData(BYTE dat);
void SendString(char *s);

void main()
{
    P0M0 = 0x00;
    P0M1 = 0x00;
    P1M0 = 0x00;
    P1M1 = 0x00;
    P2M0 = 0x00;
    P2M1 = 0x00;
    P3M0 = 0x00;
    P3M1 = 0x00;
    P4M0 = 0x00;
    P4M1 = 0x00;
    P5M0 = 0x00;
    P5M1 = 0x00;
    P6M0 = 0x00;
    P6M1 = 0x00;
    P7M0 = 0x00;
    P7M1 = 0x00;

    ACC = P_SW1;
    ACC &= ~(S1_S0 | S1_S1);    //S1_S0=0 S1_S1=0
    P_SW1 = ACC;                //(P3.0/RxD, P3.1/TxD)
    
//  ACC = P_SW1;
//  ACC &= ~(S1_S0 | S1_S1);    //S1_S0=1 S1_S1=0
//  ACC |= S1_S0;               //(P3.6/RxD_2, P3.7/TxD_2)
//  P_SW1 = ACC;  
//  
//  ACC = P_SW1;
//  ACC &= ~(S1_S0 | S1_S1);    //S1_S0=0 S1_S1=1
//  ACC |= S1_S1;               //(P1.6/RxD_3, P1.7/TxD_3)
//  P_SW1 = ACC;  

#if (PARITYBIT == NONE_PARITY)
    SCON = 0x50;                //8λɱ䲨
#elif (PARITYBIT == ODD_PARITY) || (PARITYBIT == EVEN_PARITY) || (PARITYBIT == MARK_PARITY)
    SCON = 0xda;                //9λɱ䲨,УλʼΪ1
#elif (PARITYBIT == SPACE_PARITY)
    SCON = 0xd2;                //9λɱ䲨,УλʼΪ0
#endif

    AUXR = 0x40;                //ʱ1Ϊ1Tģʽ
    TMOD = 0x20;                //ʱ1Ϊģʽ2(8λԶ)
    TL1 = (256 - (FOSC/32/BAUD));   //òװֵ
    TH1 = (256 - (FOSC/32/BAUD));
    TR1 = 1;                    //ʱ1ʼ
    ES = 1;                     //ʹܴж
    EA = 1;

    SendString("STC15F2K60S2\r\nUart Test !\r\n");
    while(1);
}

/*----------------------------
UART жϷ
-----------------------------*/
void Uart() interrupt 4 using 1
{
    if (RI)
    {
        RI = 0;                 //RIλ
        P0 = SBUF;              //P0ʾ
        P22 = RB8;              //P2.2ʾУλ
    }
    if (TI)
    {
        TI = 0;                 //TIλ
        busy = 0;               //æ־
    }
}

/*----------------------------
ʹ
----------------------------*/
void SendData(BYTE dat)
{
    while (busy);               //ȴǰݷ
    ACC = dat;                  //ȡУλP (PSW.0)
    if (P)                      //PУλ
    {
#if (PARITYBIT == ODD_PARITY)
        TB8 = 0;                //УλΪ0
#elif (PARITYBIT == EVEN_PARITY)
        TB8 = 1;                //УλΪ1
#endif
    }
    else
    {
#if (PARITYBIT == ODD_PARITY)
        TB8 = 1;                //УλΪ1
#elif (PARITYBIT == EVEN_PARITY)
        TB8 = 0;                //УλΪ0
#endif
    }
    busy = 1;
    SBUF = ACC;                 //дݵUARTݼĴ
}

/*----------------------------
ַ
----------------------------*/
void SendString(char *s)
{
    while (*s)                  //ַ־
    {
        SendData(*s++);         //͵ǰַ
    }
}

